'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const { limit, skip, sort, filters } = body;
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            query BuildSites($input: ListArguments!) {
                buildSites(input: $input) {
                data {
                    _id
                    uuid
                    siteNo
                    siteName
                    createdAt
                    updatedAt
                    expiryEnds
                    expiryStarts
                }
                totalCount
                }
            }`;
        const variables = { input: { limit, skip, sort, filters } };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.buildSites.data, totalCount: data.buildSites.totalCount }, { status: 200 });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
